// tc2sView.cpp : CTc2sView NX̓̒`s܂B
//

#include "stdafx.h"
#include "tc2s.h"
#include "tccont.h"
#include "tc2mesdlg.h"
#include "condition.h"
#include "fontdefine.h"

#include "tc2sDoc.h"
#include "tc2sView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern SCondition condition;					// Ŝ̑
/////////////////////////////////////////////////////////////////////////////
// CTc2sView

IMPLEMENT_DYNCREATE(CTc2sView, CView)

BEGIN_MESSAGE_MAP(CTc2sView, CView)
	//{{AFX_MSG_MAP(CTc2sView)
	ON_COMMAND(ID_MENU_START, OnMenuStart)
	ON_COMMAND(ID_TEXT_SAVE, OnTextSave)
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

#define		WINDOW_WIDTH		1000			// _޳̕
#define		WINDOW_HIGHT		1000			// _޳̍
#define		G_ORGX				100				// ̘̂__XW
#define		G_ORGY				150				// ̘̂__YW
#define		M_RX				350				// ̂XEϰ
#define		M_RY				100				// ̂YEϰ
#define		UR_X				(WINDOW_WIDTH-M_RX)	// ̕\͈(E)
#define		UR_Y				(WINDOW_HIGHT-M_RY)	// ̕\͈(E)
#define		GRAPH_LENGTHX		(UR_X-G_ORGX)	// ̕\ر̕
#define		GRAPH_LENGTHY		(UR_Y-G_ORGY)	// ̕\ر̍
#define		G_OFFSET			20				// ̂̏㉺̗]

#define		X_BUNKATU		10
#define		Y_BUNKATU		10

/////////////////////////////////////////////////////////////////////////////
// CTc2sView NX̍\z/

CTc2sView::CTc2sView()
{
//	m_pTc2 = new CTC2MesDlg( this );				// ޲۸ލ쐬
	m_fExtentX = 180.0f;
	m_fExtentY = 20000.0f;
	m_fStepX = GRAPH_LENGTHX / m_fExtentX;
	m_fStepY = GRAPH_LENGTHY / m_fExtentY;
	m_penFrame.CreatePen( PS_SOLID, 1, RGB( 0, 0, 255) );
	m_penGrid.CreatePen( PS_DOT, 1, RGB( 0, 0, 255) );
//	m_penDot.CreatePen( PS_SOLID, 1, RGB( 255, 0, 0) );
//	m_penLine.CreatePen( PS_SOLID, 1, RGB( 150, 55, 150) );
	m_brushParaFrame.CreateSolidBrush( RGB( 128, 0, 128) );
	m_penLine1.CreatePen( PS_SOLID, 1, RGB(   0,  0,255) );
	m_penLine2.CreatePen( PS_SOLID, 1, RGB(   0,255,  0) );
	m_penLine3.CreatePen( PS_SOLID, 1, RGB( 255,255,  0) );
	m_penLine4.CreatePen( PS_SOLID, 1, RGB( 255,  0,  0) );
}

CTc2sView::~CTc2sView()
{
//	delete m_pTc2;
}

BOOL CTc2sView::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CView::PreCreateWindow( cs ) )
		return FALSE;
	cs.style |= WS_MAXIMIZE;					// ő剻ŊJ
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CTc2sView NX̕`

void CTc2sView::OnDraw(CDC* pDC)
{
	CTc2sDoc* pDoc = GetDocument();

	if( pDoc->m_nData == 0 )			// ްꍇ
		return;							// ~
	// ܂\pҰ̐ݒ
	MakeXYaxis();
	// ޭ߰Ă̐ݒ
	CRect client;
	if( pDC->IsPrinting() ){
		client.left = client.top = 0;
		client.right = pDC->GetDeviceCaps( HORZRES );
		client.bottom = pDC->GetDeviceCaps( VERTRES );
	}
	else
		GetClientRect( client );				// ײĴر̻ނ𓾂
	pDC->SetMapMode( MM_ANISOTROPIC );			// Cӂ̒Pʌ^
	pDC->SetWindowExt( WINDOW_WIDTH, WINDOW_HIGHT );
												// ޳̘_ނݒ
	pDC->SetViewportExt( client.right, -client.bottom );
												// Y̐𔽓]
	pDC->SetViewportOrg( 0, client.bottom );
	CFont newFont;

	if(pDC->IsPrinting()){
		newFont.CreateFont( FONT_PRINT_OUT_HEIGHT, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, ANSI_CHARSET,
						 OUT_TT_PRECIS, OUT_DEFAULT_PRECIS, DEFAULT_QUALITY,
						 DEFAULT_PITCH | FF_DONTCARE, FONT_PRINT_OUT_GOTHIC );
	}
	else{
		newFont.CreateFont( FONT_SCREEN_OUT_HEIGHT, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, ANSI_CHARSET,
						 OUT_TT_PRECIS, OUT_DEFAULT_PRECIS, DEFAULT_QUALITY,
						 DEFAULT_PITCH | FF_DONTCARE, FONT_PRINT_OUT_GOTHIC );
	}

	pDC->SelectObject( &newFont );

	// g
	CPen* pOldPen = pDC->SelectObject( &m_penFrame );
	pDC->MoveTo( UR_X, G_ORGY );
	pDC->LineTo( G_ORGX, G_ORGY ); 
	pDC->LineTo( G_ORGX, UR_Y );
	pDC->LineTo( UR_X, UR_Y );
	pDC->LineTo( UR_X, G_ORGY ); 
	// ڐ(X)
	pDC->SelectObject( &m_penGrid );
	for( int x = 0; x < (int)((pDoc->m_fEnd - pDoc->m_fStart)/ pDoc->m_fStep); x++ ){
		int xx = G_ORGX + int(float(x) * m_fXstep * m_fStepX);
						// x̍Wɕϊ
		pDC->MoveTo( xx, G_ORGY );
		if( (x != 0) && (x != X_BUNKATU) )
			pDC->LineTo( xx, UR_Y );
		CString strText;
		sprintf( strText.GetBuffer(15), "%d", x );
		strText.ReleaseBuffer();
		CSize strSize = pDC->GetTextExtent( strText, strText.GetLength() );
		pDC->TextOut( xx-strSize.cx/2, G_ORGY-strSize.cy/4, strText );
	}

	// ڐ(Y)
	for( int y = 0; y <= Y_BUNKATU; y++ ){
		int yy = G_ORGY + int( float(y) * m_fYstep * m_fStepY) + G_OFFSET;
		pDC->MoveTo( G_ORGX, yy );
		CString strText;
		sprintf( strText.GetBuffer(15), "%9.0f", y*m_fYstep+m_fYstart );
		strText.ReleaseBuffer();
		if( y != Y_BUNKATU )
			pDC->LineTo( UR_X, yy );
		CSize strSize = pDC->GetTextExtent( strText, strText.GetLength() );
		pDC->TextOut( G_ORGX-strSize.cx-4, yy+strSize.cy/2, strText );
	}
	DrawGraph( pDC );
	pDC->SelectObject( pOldPen );
}

// -------------------------------------------------------------------------
//		ŏʌȉ؂̂
// -------------------------------------------------------------------------
float CTc2sView::CutLast( float& min )
{
//DWORD	u = DWORD( min ),
//		s;
	double	u = double( min ),
			s;

	for( double cmp = double(1000000000); cmp > double(0.001); cmp /= double(10) ){
		if( u >= cmp )
			break;
	}
	s = u / cmp;
	u =	s * cmp;
	s = cmp;
	min = float( u );
	return float( s );
}

// -------------------------------------------------------------------------
//		̖̂ڐ̌vZ
// -------------------------------------------------------------------------
void CTc2sView::MakeXYaxis()
{
	CTc2sDoc* pDoc = GetDocument();

	// X
	m_fExtentX = (pDoc->m_fEnd - pDoc->m_fStart - 1.0f)/ pDoc->m_fStep;	// Xް(px)̕
	m_fStepX = float(GRAPH_LENGTHX) / m_fExtentX;	// 1xޯĐ
	m_fXstart = pDoc->m_fStart;
	m_fXend = pDoc->m_fEnd- 1.0f;
//	m_fXstep = m_fExtentX / X_BUNKATU;
	m_fXstep = m_fExtentX / (int)((pDoc->m_fEnd - pDoc->m_fStart - 1.0f)/ pDoc->m_fStep);

	// Y
	float tmpMin = pDoc->m_fMinYs;

	CutLast( tmpMin );							// ŏʌȉ؂̂
//	if( tmpMin < 100.0f )							// 100̏ꍇ0ɂ
//		tmpMin = 0.0f;
	float fHeghit = pDoc->m_fMaxYs - tmpMin;	// ̖ڐ̍߂
	float fBlock = fHeghit / Y_BUNKATU;		// 10
	float keta = CutLast( fBlock );
	fBlock += keta;
	m_fExtentY = fBlock * Y_BUNKATU;
	m_fStepY = float(GRAPH_LENGTHY-G_OFFSET) / m_fExtentY;	// 1ʓޯĐ
	m_fYstart = tmpMin;
	m_fYend = tmpMin + m_fExtentY;
	m_fYstep = fBlock;
}

// -------------------------------------------------------------------------
//		̂̕\
// -------------------------------------------------------------------------
void CTc2sView::DrawGraph( CDC* pDC )
{
	int bxx, byh, byv, byp, byy;
	CTc2sDoc* pDoc = GetDocument();
	float	*tmpXData = pDoc->m_aXData;
	float	*tmpHData = pDoc->m_aHData;
	float	*tmpVData = pDoc->m_aVData;
	float	*tmpYData = pDoc->m_aYData;
	float	*tmpPData = pDoc->m_aPData;
	CRect client;

	for( int i = 0; i < (int)((pDoc->m_fEnd - pDoc->m_fStart)/ pDoc->m_fStep); i++ ){
		int xx = G_ORGX + int((i + m_fXstart -1.0f) * m_fStepX);
		int yh = G_ORGY + int((*tmpHData++ - m_fYstart) * m_fStepY) + G_OFFSET;
		int yv = G_ORGY + int((*tmpVData++ - m_fYstart) * m_fStepY) + G_OFFSET;
		int yy = G_ORGY + int((*tmpYData++ - m_fYstart) * m_fStepY) + G_OFFSET;
		int yp = G_ORGY + int((*tmpPData++ - m_fYstart) * m_fStepY) + G_OFFSET;

		pDC->SelectObject( &m_penLine1 );
		pDC->MoveTo( xx-4, yh+5 ); pDC->LineTo( xx+4, yh-5 );
		pDC->MoveTo( xx-4, yh-5 ); pDC->LineTo( xx+4, yh+5 );
		pDC->SelectObject( &m_penLine2 );
		pDC->MoveTo( xx-4, yv+5 ); pDC->LineTo( xx+4, yv+5 );
		pDC->MoveTo( xx-4, yv-5 ); pDC->LineTo( xx+4, yv+5 );
		pDC->SelectObject( &m_penLine3 );
		pDC->MoveTo( xx-4, yy+5 ); pDC->LineTo( xx+4, yy-5 );
		pDC->MoveTo( xx-4, yy-5 ); pDC->LineTo( xx+4, yy+5 );
		pDC->SelectObject( &m_penLine4 );
		pDC->MoveTo( xx-4, yp+5 ); pDC->LineTo( xx+4, yp-5 );
		pDC->MoveTo( xx-4, yp-5 ); pDC->LineTo( xx+4, yp+5 );
		
		if( i != 0 ) {
			pDC->SelectObject( &m_penLine1 );
			pDC->MoveTo( bxx, byh ); pDC->LineTo( xx, yh );
			pDC->SelectObject( &m_penLine2 );
			pDC->MoveTo( bxx, byv ); pDC->LineTo( xx, yv );
			pDC->SelectObject( &m_penLine3 );
			pDC->MoveTo( bxx, byy ); pDC->LineTo( xx, yy );
			pDC->SelectObject( &m_penLine4 );
			pDC->MoveTo( bxx, byp ); pDC->LineTo( xx, yp );
		}
		bxx = xx; byh = yh;
		byv = yv; byy = yy; byp = yp;
	}
	if( !pDC->IsPrinting() )
		pDC->SelectObject( &m_penLine );
	CFont newFont;
	newFont.CreateFont( -30, 0, 0, 0, FW_MEDIUM, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET,
						 OUT_TT_PRECIS, OUT_DEFAULT_PRECIS, PROOF_QUALITY,
						 VARIABLE_PITCH | FF_DONTCARE, "WSVbN" );

	pDC->SelectObject( &newFont );
	if( !pDC->IsPrinting() )
		pDC->SetTextColor( RGB( 0,0,128 ) ); 
	CSize strSize = pDC->GetTextExtent( "@@@", 14 );
	pDC->TextOut( G_ORGX+GRAPH_LENGTHX/2 - strSize.cx/2, G_ORGY-strSize.cy*2, "@@@", 14 );
	strSize = pDC->GetTextExtent( "Xg[^[茋", strlen("Xg[^[茋") );
	pDC->TextOut( G_ORGX+GRAPH_LENGTHX/2 - strSize.cx/2, UR_Y+strSize.cy*2, "Xg[^[茋", strlen("Xg[^[茋") );

	strSize = pDC->GetTextExtent( "w", strlen( "w" ) );
	int nHalf = strSize.cy / 2;
	pDC->TextOut( strSize.cx+3, WINDOW_HIGHT / 4 * 3-strSize.cy, "", 2 );
	pDC->TextOut( strSize.cx+3, WINDOW_HIGHT / 4 * 3-strSize.cy*6+nHalf, "", 2 );
	pDC->TextOut( strSize.cx+3, WINDOW_HIGHT / 4 * 3-strSize.cy*12+nHalf, "l", 2 );

	CString strText;
	int xStr = UR_X+strSize.cx;
	int	yStr = UR_Y;
	int	yStep = strSize.cy / 2;

	strText = "[ٖ] " + pDoc->m_strSample;
	pDC->TextOut( xStr, yStr, strText );
	yStr -= yStep*4;

	strText = "m@Horizontal(Blue)@]";
	pDC->TextOut( xStr, yStr, strText );
	yStr -= yStep*3;

	sprintf( strText.GetBuffer(50), "@@@@[ Max@] % 8.2f[um]", pDoc->m_fMaxH );
	strText.ReleaseBuffer();
	pDC->TextOut( xStr, yStr, strText );
	yStr -= yStep*3;

	sprintf( strText.GetBuffer(50), "@@@@[ Min@] % 8.2f[um]", pDoc->m_fMinH );
	strText.ReleaseBuffer();
	pDC->TextOut( xStr, yStr, strText );
	yStr -= yStep*4;

	strText = "m@Vertical@(Green)]";
	pDC->TextOut( xStr, yStr, strText );
	yStr -= yStep*3;

	sprintf( strText.GetBuffer(50), "@@@@[ Max@] % 8.2f[um]", pDoc->m_fMaxV );
	strText.ReleaseBuffer();
	pDC->TextOut( xStr, yStr, strText );
	yStr -= yStep*3;

	sprintf( strText.GetBuffer(50), "@@@@[ Min@] % 8.2f[um]", pDoc->m_fMinV );
	strText.ReleaseBuffer();
	pDC->TextOut( xStr, yStr, strText );
	yStr -= yStep*4;

	strText = "m@Yawing@(Yellow)]";
	pDC->TextOut( xStr, yStr, strText );
	yStr -= yStep*3;

	sprintf( strText.GetBuffer(50), "@@@@[ Max@] % 8.2f[sec]", pDoc->m_fMaxY );
	strText.ReleaseBuffer();
	pDC->TextOut( xStr, yStr, strText );
	yStr -= yStep*3;

	sprintf( strText.GetBuffer(50), "@@@@[ Min@] % 8.2f[sec]", pDoc->m_fMinY );
	strText.ReleaseBuffer();
	pDC->TextOut( xStr, yStr, strText );
	yStr -= yStep*4;

	strText = "m@Pitching(Red)@]";
	pDC->TextOut( xStr, yStr, strText );
	yStr -= yStep*3;

	sprintf( strText.GetBuffer(50), "@@@@[ Max@] % 8.2f[sec]", pDoc->m_fMaxP );
	strText.ReleaseBuffer();
	pDC->TextOut( xStr, yStr, strText );
	yStr -= yStep*3;

	sprintf( strText.GetBuffer(50), "@@@@[ Min@] % 8.2f[sec]", pDoc->m_fMinP );
	strText.ReleaseBuffer();
	pDC->TextOut( xStr, yStr, strText );
	yStr -= yStep*18;


	CFont newFont2;
	newFont2.CreateFont( -20, 0, 0, 0, FW_MEDIUM, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET,
						 OUT_TT_PRECIS, OUT_DEFAULT_PRECIS, PROOF_QUALITY,
						 VARIABLE_PITCH | FF_DONTCARE, "WSVbN" );

	pDC->SelectObject( &newFont2 );
	pDC->TextOut( xStr-50, yStr, COMPANY_NAME  );	
}

/////////////////////////////////////////////////////////////////////////////
// CTc2sView NẌ

BOOL CTc2sView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CTc2sView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CTc2sView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CTc2sView NX̐ff

#ifdef _DEBUG
void CTc2sView::AssertValid() const
{
	CView::AssertValid();
}

void CTc2sView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTc2sDoc* CTc2sView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTc2sDoc)));
	return (CTc2sDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTc2sView NX̃bZ[W nh


// --------------------------------------------------------------------------
//		JnO̐ݒ
// --------------------------------------------------------------------------
void CTc2sView::OnMenuStart() 
{
	CTc2sDoc* pDoc = GetDocument();
	if( condition.m_wDivn < 2 ) {
		MessageBox( "_𐳂ݒ肵ĉB", "Error", MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	pDoc->SetMeasurePara();
	pDoc->m_nData = 0;
	Tc2.m_pHData = pDoc ->m_aHData;
	Tc2.m_pVData = pDoc ->m_aVData;
	Tc2.m_pYData = pDoc ->m_aYData;
	Tc2.m_pPData = pDoc ->m_aPData;
	Tc2.m_pXData = pDoc ->m_aXData;
	Tc2.m_lLoopTimes = 0;

	int i = Tc2.DoModal();
	pDoc->m_nData = Tc2.m_lLoopTimes;
	pDoc->SetMeasureData();
	pDoc->SetModifiedFlag();				// ޷ĂɕύX
	pDoc->UpdateAllViews( NULL );			// ޭ̍XV
}

// --------------------------------------------------------------------------
//		CSV`̏o
// --------------------------------------------------------------------------
void CTc2sView::OnTextSave() 
{
	CTc2sDoc* pDoc = GetDocument();
	char fname[256];

	if( GetDocument()->GetPathName() == "" ) sprintf(fname,"Straightor");
	else {
		sprintf(fname,"%s",GetDocument()->GetPathName());
		for(WORD i=0;i<strlen(fname);i++) {
			if(fname[i]=='.') { fname[i] = '\0'; break; }
		}
	}
	CFileDialog CD(FALSE,"csv",fname,
			OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,"StraightorCsv (*.csv)|*.csv|AllFiles(*.*)|*.*||");
	if( CD.DoModal() == IDOK ) {
		CString PatnName = CD.GetPathName();
		sprintf(fname,"%s",PatnName);
		BeginWaitCursor();							// v
		pDoc->SaveTextFile( fname );	
		EndWaitCursor();
	}
	
}
